/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.BahasaDto;
import com.portofolio.service.BahasaService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/bahasa")
public class BahasaController extends LocaleController {
	@Lazy
	@Autowired
	private BahasaService bahasaService;

	@ApiOperation("Api Untuk Menyimpan Bahasa")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody BahasaDto entity, HttpServletRequest request) {
		Map<String, Object> result = bahasaService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Update Bahasa")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdBahasa", required = true) Integer kdBahasa,
			@RequestParam(value = "version", required = true) Integer version,
			@Valid @RequestBody BahasaDto entity) {
		Map<String, Object> result = bahasaService.update(entity, kdBahasa,version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menghapus Bahasa BerdasarkanKdBahasa")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "kdBahasa", required = true) Integer kdBahasa,
			@RequestParam(value = "version", required = true) Integer version) {
		Map<String, Object> result = bahasaService.deleteById(kdBahasa,version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Semua Bahasa")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> findAll(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = stringAsIntegerMaxValue) Integer rows,
			@RequestParam(value = "dir", defaultValue = "namaBahasa") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaBahasa", required = false, defaultValue = "") String namaBahasa,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = bahasaService.findAll(page, rows, sort, dir, namaBahasa,statusEnabled);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Bahasa Berdasarkan kode")
	@GetMapping("/findByKdBahasa")
	public ResponseEntity<Map<String, Object>> findByKdBahasa(
			@RequestParam(value = "kdBahasa", required = true) Integer kdBahasa) {
		Map<String, Object> result = bahasaService.findById(kdBahasa);
		return RestUtil.getJsonResponse(result);
	}


}
